import { world } from "@minecraft/server";

world.afterEvents.itemUse.subscribe((eventData) => {
    const { itemStack, source: player } = eventData;

    // Check if source exists first
    if (eventData.source === undefined) return;

    // Handle concealment book
    if (itemStack?.typeId === "amarite:enchanted_book_concealment") {
        eventData.source.runCommandAsync('tag @s add has_tag_enchantment_concealment');
        eventData.source.runCommandAsync('clear @s amarite:enchanted_book_concealment 0 1');
        eventData.source.runCommandAsync('playsound random.levelup');
        return;
    }
    
    // Handle anonymity book
    if (itemStack?.typeId === "amarite:enchanted_book_anonymity") {
        eventData.source.runCommandAsync('say hey there');
        return;
    }
});
