import { world } from "@minecraft/server";

const cooldowns = new Map();

world.afterEvents.itemUse.subscribe((eventData) => {

    const { itemStack, source: player } = eventData;

    if (itemStack?.typeId !== "amarite:amarite_mirror=resistance") {
        return;
    }
    if (eventData.source === undefined) return;
    
    const playerId = eventData.source.id;
    const currentTime = Date.now();
    
    // Check if player is on cooldown
    if (cooldowns.has(playerId)) {
        const lastUseTime = cooldowns.get(playerId);
        const timeDiff = currentTime - lastUseTime;
        
        if (timeDiff < 32000) { // 32000ms = 32 seconds
            const remainingTime = Math.ceil((32000 - timeDiff) / 1000);
            eventData.source.sendMessage(`§cCooldown: ${remainingTime} seconds remaining`);
            eventData.runCommandAsync('playsound note.bass @s');
            return;
        }
    }
    
    // Set cooldown and execute effect
    cooldowns.set(playerId, currentTime);
    eventData.source.runCommandAsync('effect @s resistance 15 0');
    eventData.source.runCommandAsync('playsound Mirror_Used @a[r=6]');
});
