import { Block } from "@minecraft/server";

//set block wall tag here
const wallTag = 'wall:is_wall'

// Add blocks that walls should NOT connect to (based on Minecraft Bedrock Edition behavior)
const nonConnectableBlocks = [
    // Trapdoors
    'minecraft:trapdoor',
    'minecraft:iron_trapdoor',
    'minecraft:acacia_trapdoor',
    'minecraft:birch_trapdoor',
    'minecraft:dark_oak_trapdoor',
    'minecraft:jungle_trapdoor',
    'minecraft:oak_trapdoor',
    'minecraft:spruce_trapdoor',
    'minecraft:crimson_trapdoor',
    'minecraft:warped_trapdoor',
    'minecraft:mangrove_trapdoor',
    'minecraft:bamboo_trapdoor',
    'minecraft:cherry_trapdoor',
    'minecraft:copper_trapdoor',
    'minecraft:exposed_copper_trapdoor',
    'minecraft:weathered_copper_trapdoor',
    'minecraft:oxidized_copper_trapdoor',
    'minecraft:waxed_copper_trapdoor',
    'minecraft:waxed_exposed_copper_trapdoor',
    'minecraft:waxed_weathered_copper_trapdoor',
    'minecraft:waxed_oxidized_copper_trapdoor',
    
    // Doors
    'minecraft:wooden_door',
    'minecraft:iron_door',
    'minecraft:acacia_door',
    'minecraft:birch_door',
    'minecraft:dark_oak_door',
    'minecraft:jungle_door',
    'minecraft:oak_door',
    'minecraft:spruce_door',
    'minecraft:crimson_door',
    'minecraft:warped_door',
    'minecraft:mangrove_door',
    'minecraft:bamboo_door',
    'minecraft:cherry_door',
    'minecraft:copper_door',
    'minecraft:exposed_copper_door',
    'minecraft:weathered_copper_door',
    'minecraft:oxidized_copper_door',
    'minecraft:waxed_copper_door',
    'minecraft:waxed_exposed_copper_door',
    'minecraft:waxed_weathered_copper_door',
    'minecraft:waxed_oxidized_copper_door',
    
    // Fences
    'minecraft:oak_fence',
    'minecraft:acacia_fence',
    'minecraft:birch_fence',
    'minecraft:dark_oak_fence',
    'minecraft:jungle_fence',
    'minecraft:spruce_fence',
    'minecraft:crimson_fence',
    'minecraft:warped_fence',
    'minecraft:mangrove_fence',
    'minecraft:bamboo_fence',
    'minecraft:cherry_fence',
    
    // Glass blocks and panes
    'minecraft:glass',
    'minecraft:tinted_glass',
    'minecraft:glass_pane',
    'minecraft:white_stained_glass',
    'minecraft:orange_stained_glass',
    'minecraft:magenta_stained_glass',
    'minecraft:light_blue_stained_glass',
    'minecraft:yellow_stained_glass',
    'minecraft:lime_stained_glass',
    'minecraft:pink_stained_glass',
    'minecraft:gray_stained_glass',
    'minecraft:light_gray_stained_glass',
    'minecraft:cyan_stained_glass',
    'minecraft:purple_stained_glass',
    'minecraft:blue_stained_glass',
    'minecraft:brown_stained_glass',
    'minecraft:green_stained_glass',
    'minecraft:red_stained_glass',
    'minecraft:black_stained_glass',
    'minecraft:white_stained_glass_pane',
    'minecraft:orange_stained_glass_pane',
    'minecraft:magenta_stained_glass_pane',
    'minecraft:light_blue_stained_glass_pane',
    'minecraft:yellow_stained_glass_pane',
    'minecraft:lime_stained_glass_pane',
    'minecraft:pink_stained_glass_pane',
    'minecraft:gray_stained_glass_pane',
    'minecraft:light_gray_stained_glass_pane',
    'minecraft:cyan_stained_glass_pane',
    'minecraft:purple_stained_glass_pane',
    'minecraft:blue_stained_glass_pane',
    'minecraft:brown_stained_glass_pane',
    'minecraft:green_stained_glass_pane',
    'minecraft:red_stained_glass_pane',
    'minecraft:black_stained_glass_pane',
    
    // Leaves
    'minecraft:leaves',
    'minecraft:leaves2',
    'minecraft:azalea_leaves',
    'minecraft:azalea_leaves_flowered',
    'minecraft:acacia_leaves',
    'minecraft:birch_leaves',
    'minecraft:dark_oak_leaves',
    'minecraft:jungle_leaves',
    'minecraft:oak_leaves',
    'minecraft:spruce_leaves',
    'minecraft:mangrove_leaves',
    'minecraft:cherry_leaves',
    
    // Slabs (bottom slabs don't connect, top slabs might)
    'minecraft:stone_slab',
    'minecraft:stone_slab2',
    'minecraft:stone_slab3',
    'minecraft:stone_slab4',
    'minecraft:wooden_slab',
    'minecraft:double_stone_slab',
    'minecraft:double_stone_slab2',
    'minecraft:double_stone_slab3',
    'minecraft:double_stone_slab4',
    'minecraft:double_wooden_slab',
    
    // Stairs
    'minecraft:oak_stairs',
    'minecraft:stone_stairs',
    'minecraft:brick_stairs',
    'minecraft:stone_brick_stairs',
    'minecraft:nether_brick_stairs',
    'minecraft:sandstone_stairs',
    'minecraft:spruce_stairs',
    'minecraft:birch_stairs',
    'minecraft:jungle_stairs',
    'minecraft:acacia_stairs',
    'minecraft:dark_oak_stairs',
    'minecraft:red_sandstone_stairs',
    'minecraft:purpur_stairs',
    'minecraft:prismarine_stairs',
    'minecraft:prismarine_bricks_stairs',
    'minecraft:dark_prismarine_stairs',
    'minecraft:crimson_stairs',
    'minecraft:warped_stairs',
    'minecraft:blackstone_stairs',
    'minecraft:polished_blackstone_stairs',
    'minecraft:polished_blackstone_brick_stairs',
    'minecraft:cut_copper_stairs',
    'minecraft:exposed_cut_copper_stairs',
    'minecraft:weathered_cut_copper_stairs',
    'minecraft:oxidized_cut_copper_stairs',
    'minecraft:waxed_cut_copper_stairs',
    'minecraft:waxed_exposed_cut_copper_stairs',
    'minecraft:waxed_weathered_cut_copper_stairs',
    'minecraft:waxed_oxidized_cut_copper_stairs',
    'minecraft:cobbled_deepslate_stairs',
    'minecraft:polished_deepslate_stairs',
    'minecraft:deepslate_brick_stairs',
    'minecraft:deepslate_tile_stairs',
    'minecraft:mangrove_stairs',
    'minecraft:mud_brick_stairs',
    'minecraft:bamboo_stairs',
    'minecraft:bamboo_mosaic_stairs',
    'minecraft:cherry_stairs',
    
    // Redstone components
    'minecraft:redstone_wire',
    'minecraft:redstone_torch',
    'minecraft:unlit_redstone_torch',
    'minecraft:redstone_lamp',
    'minecraft:lit_redstone_lamp',
    'minecraft:lever',
    'minecraft:stone_button',
    'minecraft:wooden_button',
    'minecraft:acacia_button',
    'minecraft:birch_button',
    'minecraft:dark_oak_button',
    'minecraft:jungle_button',
    'minecraft:spruce_button',
    'minecraft:crimson_button',
    'minecraft:warped_button',
    'minecraft:mangrove_button',
    'minecraft:bamboo_button',
    'minecraft:cherry_button',
    'minecraft:stone_pressure_plate',
    'minecraft:wooden_pressure_plate',
    'minecraft:light_weighted_pressure_plate',
    'minecraft:heavy_weighted_pressure_plate',
    'minecraft:acacia_pressure_plate',
    'minecraft:birch_pressure_plate',
    'minecraft:dark_oak_pressure_plate',
    'minecraft:jungle_pressure_plate',
    'minecraft:spruce_pressure_plate',
    'minecraft:crimson_pressure_plate',
    'minecraft:warped_pressure_plate',
    'minecraft:mangrove_pressure_plate',
    'minecraft:bamboo_pressure_plate',
    'minecraft:cherry_pressure_plate',
    'minecraft:polished_blackstone_pressure_plate',
    'minecraft:repeater',
    'minecraft:unpowered_repeater',
    'minecraft:powered_repeater',
    'minecraft:comparator',
    'minecraft:unpowered_comparator',
    'minecraft:powered_comparator',
    'minecraft:daylight_detector',
    'minecraft:daylight_detector_inverted',
    'minecraft:tripwire_hook',
    'minecraft:trapped_chest',
    'minecraft:hopper',
    'minecraft:dropper',
    'minecraft:dispenser',
    'minecraft:piston_arm_collision',
    'minecraft:moving_block',
    'minecraft:observer',
    
    // Plants and organic blocks
    'minecraft:cactus',
    'minecraft:reeds',
    'minecraft:bamboo',
    'minecraft:bamboo_sapling',
    'minecraft:kelp',
    'minecraft:dried_kelp_block',
    'minecraft:sea_pickle',
    'minecraft:turtle_egg',
    'minecraft:sniffer_egg',
    'minecraft:frog_spawn',
    
    // Banners and signs
    'minecraft:standing_banner',
    'minecraft:wall_banner',
    'minecraft:standing_sign',
    'minecraft:wall_sign',
    'minecraft:oak_hanging_sign',
    'minecraft:spruce_hanging_sign',
    'minecraft:birch_hanging_sign',
    'minecraft:jungle_hanging_sign',
    'minecraft:acacia_hanging_sign',
    'minecraft:dark_oak_hanging_sign',
    'minecraft:crimson_hanging_sign',
    'minecraft:warped_hanging_sign',
    'minecraft:mangrove_hanging_sign',
    'minecraft:bamboo_hanging_sign',
    'minecraft:cherry_hanging_sign',
    
    // Beds
    'minecraft:bed',
    
    // Chests and storage
    'minecraft:chest',
    'minecraft:ender_chest',
    'minecraft:shulker_box',
    'minecraft:undyed_shulker_box',
    'minecraft:white_shulker_box',
    'minecraft:orange_shulker_box',
    'minecraft:magenta_shulker_box',
    'minecraft:light_blue_shulker_box',
    'minecraft:yellow_shulker_box',
    'minecraft:lime_shulker_box',
    'minecraft:pink_shulker_box',
    'minecraft:gray_shulker_box',
    'minecraft:light_gray_shulker_box',
    'minecraft:cyan_shulker_box',
    'minecraft:purple_shulker_box',
    'minecraft:blue_shulker_box',
    'minecraft:brown_shulker_box',
    'minecraft:green_shulker_box',
    'minecraft:red_shulker_box',
    'minecraft:black_shulker_box',
    
    // Utility blocks
    'minecraft:conduit',
    'minecraft:bell',
    'minecraft:lantern',
    'minecraft:soul_lantern',
    'minecraft:campfire',
    'minecraft:soul_campfire',
    'minecraft:scaffolding',
    'minecraft:lectern',
    'minecraft:cauldron',
    'minecraft:lava_cauldron',
    'minecraft:water_cauldron',
    'minecraft:powder_snow_cauldron',
    
    // Workstations
    'minecraft:anvil',
    'minecraft:damaged_anvil',
    'minecraft:deprecated_anvil',
    'minecraft:enchanting_table',
    'minecraft:brewing_stand',
    'minecraft:stonecutter',
    'minecraft:stonecutter_block',
    'minecraft:grindstone',
    
    // Spawners and special blocks,
    'minecraft:end_portal',
    'minecraft:end_portal_frame',
    'minecraft:endway',
    'minecraft:structure_block',
    'minecraft:structure_void',
    'minecraft:jigsaw',
    'minecraft:command_block',
    'minecraft:repeating_command_block',
    'minecraft:chain_command_block',
    'minecraft:barrier',
    'minecraft:light_block',
    'minecraft:allow',
    'minecraft:deny',
    'minecraft:border_block',
    
    // Heads and decorative
    'minecraft:skull',
    'minecraft:mob_head',
    'minecraft:dragon_egg',
    'minecraft:flower_pot',
    'minecraft:decorated_pot',
    'minecraft:ladder',
    
    // Rails
    'minecraft:rail',
    'minecraft:golden_rail',
    'minecraft:detector_rail',
    'minecraft:activator_rail',

    // Extra
    'minecraft:wildflowers',
    'minecraft:tall_grass',
    'minecraft:large_fern',
    'minecraft:tall_seagrass',
    'minecraft:sea_pickle',
    'minecraft:dead_bush',
    'minecraft:cactus',
    'minecraft:sugar_cane',
    'minecraft:bamboo',
    'minecraft:bamboo_sapling',
    'minecraft:kelp',
    'minecraft:short_grass',
    'minecraft:frame',
    'minecraft:glow_frame',
    'minecraft:heavy_core',
    'minecraft:chain',
    'minecraft:deadbush',
    'minecraft:oak_sapling',
    'minecraft:spruce_sapling',
    'minecraft:dark_oak_sapling',
    'minecraft:acacia_sapling',
    'minecraft:birch_sapling',
    'minecraft:cherry_sapling',
    'minecraft:jungle_sapling',
    'minecraft:pale_oak_sapling',
    'minecraft:mangrove_propagule',
    'minecraft:farmland',
    'minecraft:grass_path',
    'minecraft:',
    'minecraft:',
    'minecraft:',
    'minecraft:',
    'minecraft:',
    'minecraft:',
    'minecraft:',
    'minecraft:',
    'minecraft:',
    'minecraft:',
    'minecraft:',
    'minecraft:',
    'minecraft:'
];

// Add blocks that walls SHOULD connect to (optional - for more precise control)
const connectableBlocks = [
    // Other walls
    wallTag, // Will be checked via hasTag
    // Solid blocks
    'minecraft:stone',
    'minecraft:cobblestone',
    'minecraft:stone_bricks',
    // Add more blocks as needed
];

export class wall_Manager {
    
// Helper method to check if a block should be connected to
static shouldConnectToBlock(block) {
    if (!block || block.isLiquid || block.isAir) {
        return false;
    }
    
    // Don't connect to blocks with custom tags
    if (block.hasTag('custom_stairs') || 
        block.hasTag('custom_slab') || 
        block.hasTag('custom_trapdoor') || 
        block.hasTag('custom_door') || 
        block.hasTag('custom_fence')) {
        return false;
    }
    
    // Don't connect to blocks in the non-connectable list
    if (nonConnectableBlocks.includes(block.typeId)) {
        return false;
    }
    
    // Always connect to other walls
    if (block.hasTag(wallTag)) {
        return true;
    }
    
    // Default: connect to any solid block not in the exclusion list
    return true;
}
    
    static update_Wall_States(Wall) {
        let above = undefined;
        try {
            above = Wall.above(1);
        } catch { }
        let north = undefined;
        try {
            north = Wall.north(1);
        } catch { }
        let south = undefined;
        try {
            south = Wall.south(1);
        } catch { }
        let east = undefined;
        try {
            east = Wall.east(1);
        } catch { }
        let west = undefined;
        try {
            west = Wall.west(1);
        } catch { }
        
        const blocks = [
            { block: above, side: "up" },
            { block: north, side: "north" },
            { block: south, side: "south" },
            { block: east, side: "east" },
            { block: west, side: "west" },
        ];
        
        for (const blockData of blocks) {
            const shouldConnect = this.shouldConnectToBlock(blockData.block);
            
            if (blockData.side != "up") {
                Wall.setPermutation(Wall.permutation.withState("wall:connect_" + blockData.side, shouldConnect));
            } else {
                Wall.setPermutation(Wall.permutation.withState("wall:top_bit", shouldConnect));
            }
        }
        
        const north_state = Wall.permutation.getState("wall:connect_north");
        const south_state = Wall.permutation.getState("wall:connect_south");
        const east_state = Wall.permutation.getState("wall:connect_east");
        const west_state = Wall.permutation.getState("wall:connect_west");
        
        if (
            (north_state && south_state && !east_state && !west_state) ||
            (!north_state && !south_state && east_state && west_state)
        ) {
            Wall.setPermutation(Wall.permutation.withState("wall:slim", true));
            if (north_state && south_state) {
                Wall.setPermutation(Wall.permutation.withState("wall:slim_bit", "north_south"));
            } else {
                Wall.setPermutation(Wall.permutation.withState("wall:slim_bit", "east_west"));
            }
        } else {
            Wall.setPermutation(Wall.permutation.withState("wall:slim", false));
        }
    }
    
    static updateWallsAround(Block) {
        let above = undefined;
        try {
            above = Block.above(1);
        } catch { }
        let below = undefined;
        try {
            below = Block.below(1);
        } catch { }
        let north = undefined;
        try {
            north = Block.north(1);
        } catch { }
        let south = undefined;
        try {
            south = Block.south(1);
        } catch { }
        let east = undefined;
        try {
            east = Block.east(1);
        } catch { }
        let west = undefined;
        try {
            west = Block.west(1);
        } catch { }
        
        const blocks = [Block, above, below, north, south, east, west];
        for (const block of blocks) {
            if (block != undefined) {
                if (block.hasTag(wallTag)) this.update_Wall_States(block);
            }
        }
    }
}
