import {world, system} from "@minecraft/server"


const lores = {
    //the item's typeId, followed by the lore in an array format.
    //Examples:
    "amarite:amarite_longsword": ["§r§9Amarite\n§7Can block attacks to absorb half the damage dealt."],

    "amarite:amarite_longsword=accumulate": ["§r§9Amarite\n§7Can block attacks to absorb half the damage dealt.\nEnchantments\n§6     Accumulate"],

    "amarite:amarite_longsword_accumulate_biggamers4u": ["§r§eSword Made For BigGamers4u\n\n§9Amarite\n§7Can block attacks to absorb half the damage dealt.\nEnchantments\n§6     Accumulate"],

    "amarite:amarite_longsword=double_dash": ["§r§9Amarite\n§7Can block attacks to absorb half the damage dealt.\nEnchantments\n§6    Double Dash"],

    "amarite:win_cookie": ["§r§7This is what the point of the mask is."],
    

    "amarite:amarite_mirror=haste": ["§r§9Haste (00:15)\n§r§7Has a cooldown of 00:05 seconds and lasts for 15 seconds."],

    "amarite:amarite_mirror=speed": ["§r§9Speed (00:15)\n§r§7Has a cooldown of 00:06 seconds and lasts for 15 seconds."],

    "amarite:amarite_mirror=conduit": ["§r§9Conduit (00:15)\n§r§7Has a cooldown of 00:12 seconds and lasts for 15 seconds."],

    "amarite:amarite_mirror=resistance": ["§r§9Resistance (00:15)\n§r§7Has a cooldown of 00:32 seconds and lasts for 15 seconds."],

    "amarite:amarite_mirror=jump_boost": ["§r§9Jump Boost (00:15)\n§r§7Has a cooldown of 00:04 seconds and lasts for 15 seconds."],

    "amarite:amarite_mirror=strength": ["§r§9Strength (00:15)\n§r§7Has a cooldown of 00:28 seconds and lasts for 15 seconds."],
    
    "amarite:amarite_mirror=regeneration": ["§r§9Regeneration (00:15)\n§r§7Has a cooldown of 00:32 seconds and lasts for 15 seconds."],


    "amarite:axolotl_mask": ["§r§9Amarite\n§7Hides your identity.\nModel can be offset with right click.\nEquippable in the §9Main Hand §7slot"],

    "amarite:bunny_mask": ["§r§9Amarite\n§7Hides your identity.\nModel can be offset with right click.\nEquippable in the §9Main Hand §7slot"],

    "amarite:butterfly_mask": ["§r§9Amarite\n§7Hides your identity.\nModel can be offset with right click.\nEquippable in the §9Main Hand §7slot"],

    "amarite:crown_mask": ["§r§9Amarite\n§7Hides your identity.\nModel can be offset with right click.\nEquippable in the §9Main Hand §7slot"],

    "amarite:demon_mask": ["§r§9Amarite\n§7Hides your identity.\nModel can be offset with right click.\nEquippable in the §9Main Hand §7slot"],

    "amarite:fox_mask": ["§r§9Amarite\n§7Hides your identity.\nModel can be offset with right click.\nEquippable in the §9Main Hand §7slot"],

    "amarite:guardian_mask": ["§r§9Amarite\n§7Hides your identity.\nModel can be offset with right click.\nEquippable in the §9Main Hand §7slot"],

    "amarite:moon_mask": ["§r§9Amarite\n§7Hides your identity.\nModel can be offset with right click.\nEquippable in the §9Main Hand §7slot"],

    "amarite:oni_mask": ["§r§9Amarite\n§7Hides your identity.\nModel can be offset with right click.\nEquippable in the §9Main Hand §7slot"],

    "amarite:unicorn_mask": ["§r§9Amarite\n§7Hides your identity.\nModel can be offset with right click.\nEquippable in the §9Main Hand §7slot"],

    "amarite:warden_mask": ["§r§9Amarite\n§7Hides your identity.\nModel can be offset with right click.\nEquippable in the §9Main Hand §7slot"],

    "amarite:winsweep_mask": ["§r§9Amarite\n§7Hides your identity.\nModel can be offset with right click.\nEquippable in the §9Main Hand §7slot"],

    //An example of using a arrow function to get a variable in the lore
    "minecraft:custom_item_name_player": [(player) => (`§f§2${player.name}`),"§aanother line"]
};

system.runInterval(() => {
    for (const player of world.getPlayers()) {
        const playerInv = player.getComponent("inventory").container;
        const items = Array.from({ length: playerInv.size })
            .map((_, i) => playerInv.getItem(i));
        items.forEach((item,slot) => {
            if (item?.typeId in lores){
                if (item.getLore() == ""){
                    const lore = lores[item.typeId]
                        .map(line => typeof line === 'function' ? line(player) : line);
                    item.setLore(lore);
                        playerInv.setItem(slot, item);
                }
            }
        })
    }
},1);
